Option Explicit
'
'   Sample aliases for profile strings
'
Declare Function GetPrivateProfileStringByKeyName% Lib "Kernel" Alias "GetPrivateProfileString" (ByVal lpSection$, ByVal lpKeyName$, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpfilename$)
Declare Function WritePrivateProfileStringByKeyName% Lib "Kernel" Alias "WritePrivateProfileString" (ByVal lpSection$, ByVal lpKeyName$, ByVal lpString$, ByVal lplFileName$)
Declare Function GetPrivateProfileStringKeys% Lib "Kernel" Alias "GetPrivateProfileString" (ByVal lpSection$, ByVal lpKeyName&, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpfilename$)
Declare Function WritePrivateProfileStringByKeyNameDelete% Lib "Kernel" Alias "WritePrivateProfileString" (ByVal lpSection$, ByVal lpKeyName$, ByVal lpString&, ByVal lplFileName$)
Declare Function WritePrivateProfileStringToDeleteKey% Lib "Kernel" Alias "WritePrivateProfileString" (ByVal lpSection$, ByVal lpKeyName$, ByVal lpString&, ByVal lplFileName$)
Declare Function WritePrivateProfileStringToDeleteSection% Lib "Kernel" Alias "WritePrivateProfileString" (ByVal lpSection$, ByVal lpKeyName&, ByVal lpString&, ByVal lplFileName$)

'
' An example of modular programming - This provides a safer
' interface to GetPrivateProfileString
'
Function VBGetPrivateProfileString (ByVal section$, ByVal key$, File$) As String
    Dim KeyValue$
    Dim bytes%
    KeyValue$ = String$(128, 0)
    
    bytes% = GetPrivateProfileStringByKeyName(section$, key$, "", KeyValue$, 127, File$)

    If bytes% > 1 Then
        KeyValue$ = Left$(KeyValue$, bytes%)
    End If
    
    VBGetPrivateProfileString = KeyValue$

End Function

