VERSION 4.00
Begin VB.Form frmScroll 
   Caption         =   "Scrolling Example"
   ClientHeight    =   2835
   ClientLeft      =   2280
   ClientTop       =   1995
   ClientWidth     =   3975
   ClipControls    =   0   'False
   Height          =   3240
   Left            =   2220
   LinkTopic       =   "Form1"
   ScaleHeight     =   189
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   265
   Top             =   1650
   Width           =   4095
   Begin VB.CommandButton cmdScroll2 
      Caption         =   "Scroll Window2"
      Height          =   435
      Left            =   2220
      TabIndex        =   2
      Top             =   720
      Width           =   1395
   End
   Begin VB.CommandButton cmdScroll1 
      Caption         =   "ScrollWindow"
      Height          =   435
      Left            =   2220
      TabIndex        =   1
      Top             =   120
      Width           =   1395
   End
   Begin VB.CommandButton cmdScrollEx 
      Caption         =   "ScrollWindowEx"
      Height          =   435
      Left            =   2220
      TabIndex        =   0
      Top             =   1320
      Width           =   1395
   End
End
Attribute VB_Name = "frmScroll"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
' Copyright  1996 by Desaware. All Rights Reserved

'**********************************
'**  Constant Definitions:

#If Win32 Then
Private Const SW_ERASE& = &H4
Private Const SW_INVALIDATE& = &H2
Private Const SW_SCROLLCHILDREN = &H1
#End If 'WIN32

'**********************************
'**  Function Declarations:

#If Win32 Then
Private Declare Function ScrollWindow Lib "user32" (ByVal hWnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, lpRect As RECT, lpClipRect As RECT) As Long
Private Declare Function ScrollWindowByNum& Lib "user32" Alias "ScrollWindow" (ByVal hWnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, ByVal lpRect As Long, ByVal lpClipRect As Long)
Private Declare Function ScrollWindowEx& Lib "user32" (ByVal hWnd As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, lprcClip As RECT, ByVal hrgnUpdate As Long, lprcUpdate As RECT, ByVal fuScroll As Long)
Private Declare Function ScrollWindowExByNum& Lib "user32" Alias "ScrollWindowEx" (ByVal hWnd As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, lprcClip As RECT, ByVal hrgnUpdate As Long, ByVal lprcUpdate As Long, ByVal fuScroll As Long)
Private Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function UpdateWindow& Lib "user32" (ByVal hWnd As Long)
#End If 'WIN32


'**********************************
'**  Type Definitions:

#If Win32 Then
Private Type RECT
        left As Long
        top As Long
        right As Long
        bottom As Long
End Type
#End If 'WIN32 Types

Private Sub cmdScroll1_Click()
    Dim dl&
    dl& = ScrollWindowByNum&(Me.hWnd, 15, 10, 0, 0)

End Sub





Private Sub cmdScroll2_Click()
    Dim rc1 As RECT
    Dim rc2 As RECT
    Dim dl&
    ' Scroll the entire client area
    dl& = GetClientRect(Me.hWnd, rc1)
    LSet rc2 = rc1
    ' But specify a smaller clipping rectangle
    dl& = InflateRect(rc2, -30, -30)
    ' Note how the controls don't move - but the image of them does!
    dl& = ScrollWindow&(Me.hWnd, 15, 10, rc1, rc2)

End Sub

Private Sub cmdScrollEx_Click()
    Dim dl&
    Dim rc1 As RECT
    Dim rc2 As RECT
    dl& = GetClientRect(Me.hWnd, rc1)
    LSet rc2 = rc1

    dl& = ScrollWindowExByNum&(Me.hWnd, 15, 10, rc1, rc2, 0, 0, _
                       SW_INVALIDATE Or SW_ERASE Or SW_SCROLLCHILDREN)

End Sub


'
' Draw a line that
'
Private Sub Form_Paint()
    Line (20, 20)-(200, 200)
End Sub


