VERSION 4.00
Begin VB.Form frmPrintInfo 
   Caption         =   "Printer Info"
   ClientHeight    =   3045
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   5145
   Height          =   3450
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   3045
   ScaleWidth      =   5145
   Top             =   1170
   Width           =   5265
   Begin VB.CommandButton Command1 
      Caption         =   "GetInfo"
      Height          =   495
      Left            =   3600
      TabIndex        =   3
      Top             =   360
      Width           =   1215
   End
   Begin VB.TextBox txtDescription 
      Height          =   1035
      Left            =   300
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   960
      Width           =   3075
   End
   Begin VB.TextBox txtPRName 
      Height          =   285
      Left            =   1560
      TabIndex        =   0
      Text            =   "HPLJ"
      Top             =   360
      Width           =   1815
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Printer Name:"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   420
      Width           =   1275
   End
End
Attribute VB_Name = "frmPrintInfo"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
' Copyright  1996 by Desaware Inc. All Rights Reserved

'**********************************
'**  Type Definitions:

#If Win32 Then
Private Type PRINTER_INFO_1
    flags As Long
    pDescription As Long
    pName As Long
    pComment As Long
End Type


#End If 'WIN32 Types

'**********************************
'**  Function Declarations:

#If Win32 Then
Private Declare Function OpenPrinter& Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, ByVal pDefault As Long)
Private Declare Function GetPrinter& Lib "winspool.drv" Alias "GetPrinterA" (ByVal hPrinter As Long, ByVal Level As Long, pPrinter As Byte, ByVal cbBuf As Long, pcbNeeded As Long)
Private Declare Function ClosePrinter& Lib "winspool.drv" (ByVal hPrinter As Long)
#End If 'WIN32

Private Sub Command1_Click()
    Dim pi As PRINTER_INFO_1
    Dim hPrinter&, res&
    Dim needed&
    
    res = OpenPrinter(txtPRName.Text, hPrinter, 0)
    If res = 0 Then
        MsgBox "Can't open printer - Specify a valid printer name"
        Exit Sub
    End If
    ' Find out how large the buffer needs to be
    res = GetPrinter(hPrinter, 1, 0, 0, needed)
    ReDim buffer(needed) As Byte
    res = GetPrinter(hPrinter, 1, buffer(0), needed, needed)
    ' Copy to a structure
    agCopyData buffer(0), pi, Len(pi)
    txtDescription.Text = agGetStringFromPointer(pi.pDescription)
    
    Call ClosePrinter(hPrinter)
End Sub

