Attribute VB_Name = "modRegion"
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

Public Const rRECT = 0
Public Const rROUNDRECT = 1
Public Const rELLIPTIC = 2
Public Const rPOLYGON = 3
Public Const rPOLYPOLYGON = 4

'*********************************************************************
#If Win32 Then
Public Const ALTERNATE = 1
Public Const WINDING = 2
Public Const RGN_AND = 1
Public Const RGN_COPY = 5
Public Const RGN_DIFF = 4
Public Const RGN_OR = 2
Public Const RGN_XOR = 3
#Else
Public Const ALTERNATE = 1
Public Const WINDING = 2
Public Const RGN_AND = 1
Public Const RGN_COPY = 5
Public Const RGN_DIFF = 4
Public Const RGN_OR = 2
Public Const RGN_XOR = 3
#End If 'WIN32


#If Win32 Then

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
#Else
Public Type RECT
    Left As Integer
    Top As Integer
    Right As Integer
    Bottom As Integer
End Type

Public Type POINTAPI
    X As Integer
    Y As Integer
End Type
#End If 'WIN32 Types



#If Win32 Then
Public Declare Function RestoreDC& Lib "gdi32" (ByVal hDC As Long, ByVal nSavedDC As Long)
Public Declare Function SaveDC& Lib "gdi32" (ByVal hDC As Long)
Public Declare Function PaintRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long)
Public Declare Function CombineRgn& Lib "gdi32" (ByVal hDest As Long, ByVal hSrc1 As Long, ByVal hsrc2 As Long, ByVal fHow As Long)
Public Declare Function CreateEllipticRgn& Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long)
Public Declare Function CreatePolygonRgn& Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long)
Public Declare Function CreatePolyPolygonRgn& Lib "gdi32" (lpPoint As POINTAPI, lpPolyCounts As Long, ByVal nCount As Long, ByVal nPolyFillMode As Long)
Public Declare Function CreateRectRgn& Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long)
Public Declare Function CreateRoundRectRgn& Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long)
Public Declare Function FrameRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long, ByVal hBrush As Long, ByVal nWidth As Long, ByVal nHeight As Long)
Public Declare Function SelectClipRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long)
Public Declare Function PtInRegion& Lib "gdi32" (ByVal hRgn As Long, ByVal X As Long, ByVal Y As Long)
Public Declare Function DeleteObject& Lib "gdi32" (ByVal hObject As Long)
Public Declare Function CreateSolidBrush& Lib "gdi32" (ByVal crColor As Long)
#Else
Public Declare Function SaveDC% Lib "GDI" (ByVal hDC As Integer)
Public Declare Function RestoreDC% Lib "GDI" (ByVal hDC As Integer, ByVal nSavedDC As Integer)
Public Declare Function CombineRgn% Lib "GDI" (ByVal hDestRgn As Integer, ByVal hSrcRgn1 As Integer, ByVal hSrcRgn2 As Integer, ByVal nCombineMode As Integer)
Public Declare Function CreateEllipticRgn% Lib "GDI" (ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer)
Public Declare Function CreatePolygonRgn% Lib "GDI" (lpPoints As POINTAPI, ByVal nCount As Integer, ByVal nPolyFillMode As Integer)
Public Declare Function CreatePolyPolygonRgn% Lib "GDI" (lpPoints As POINTAPI, lpPolyCounts As Integer, ByVal nCount As Integer, ByVal nPolyFillMode As Integer)
Public Declare Function CreateRectRgn% Lib "GDI" (ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer)
Public Declare Function CreateRoundRectRgn% Lib "GDI" (ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer, ByVal X3 As Integer, ByVal Y3 As Integer)
Public Declare Function CreateSolidBrush% Lib "GDI" (ByVal crColor As Long)
Public Declare Function DeleteObject% Lib "GDI" (ByVal hObject As Integer)
Public Declare Function FrameRgn% Lib "GDI" (ByVal hDC As Integer, ByVal hRgn As Integer, ByVal hBrush As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer)
Public Declare Function PtInRegion% Lib "GDI" (ByVal hRgn As Integer, ByVal X As Integer, ByVal Y As Integer)
Public Declare Function SelectObject% Lib "GDI" (ByVal hDC As Integer, ByVal hObject As Integer)
Public Declare Function PaintRgn% Lib "GDI" (ByVal hDC As Integer, ByVal hRgn As Integer)
Public Declare Function SelectClipRgn% Lib "GDI" (ByVal hDC%, ByVal hRgn%)
#End If 'WIN32


