VERSION 4.00
Begin VB.Form frmDevIO 
   Caption         =   "DeviceIoControl Example"
   ClientHeight    =   3240
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   5955
   Height          =   3645
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   3240
   ScaleWidth      =   5955
   Top             =   1170
   Width           =   6075
   Begin VB.CommandButton Command2 
      Caption         =   "A:"
      Height          =   435
      Left            =   120
      TabIndex        =   2
      Top             =   840
      Width           =   1575
   End
   Begin VB.ListBox List1 
      Height          =   2760
      Left            =   2160
      TabIndex        =   1
      Top             =   240
      Width           =   3555
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Physical Drive 0"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "This sample shows how to retreive disk geometry for physical and logical drives. Some capabilities are NT only."
      Height          =   1035
      Left            =   120
      TabIndex        =   3
      Top             =   1500
      Width           =   1815
   End
End
Attribute VB_Name = "frmDevIO"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

Private Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, lpInBuffer As Any, ByVal nInBufferSize As Long, lpOutBuffer As Any, ByVal nOutBufferSize As Long, lpBytesReturned As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long

Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2
Private Const OPEN_EXISTING = 3
Private Const IOCTL_DISK_GET_DRIVE_GEOMETRY = &H70000

Private Type DISK_GEOMETRY
    CylindersLow As Long
    CylindersHigh As Long
    MediaType As Long
    TracksPerCylinder As Long
    SectorsPerTrack As Long
    BytesPerSector As Long
End Type



Private Sub Command1_Click()
   Dim fhnd&
   Dim res&
   Dim dg As DISK_GEOMETRY
   Dim bytesread As Long
   fhnd = CreateFile("\\.\PhysicalDrive0", 0, FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0)
   If fhnd = -1 Then
      MsgBox "Unable to open PhysicalDrive0"
      Exit Sub
   End If
   res = DeviceIoControl(fhnd, IOCTL_DISK_GET_DRIVE_GEOMETRY, ByVal 0, 0, dg, Len(dg), bytesread, 0)
   If res = 0 Then
      MsgBox "DeviceIoControl failed " & Hex$(GetLastError())
      Exit Sub
   End If
   List1.AddItem "Cylinders: " & dg.CylindersLow
   List1.AddItem "TracksPerCylinder: " & dg.TracksPerCylinder
   List1.AddItem "SectorsPerTrack: " & dg.SectorsPerTrack
   List1.AddItem "BytesPerSector: " & dg.BytesPerSector
   Call CloseHandle(fhnd)
End Sub

Private Sub Command2_Click()
   Dim fhnd&
   Dim res&
   Dim dg As DISK_GEOMETRY
   Dim bytesread As Long
   fhnd = CreateFile("\\.\A:", 0, FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0)
   If fhnd = -1 Then
      MsgBox "Unable to open A:"
      Exit Sub
   End If
   res = DeviceIoControl(fhnd, IOCTL_DISK_GET_DRIVE_GEOMETRY, ByVal 0, 0, dg, Len(dg), bytesread, 0)
   If res = 0 Then
      MsgBox "DeviceIoControl failed " & Hex$(GetLastError())
      Exit Sub
   End If
   List1.AddItem "Cylinders: " & dg.CylindersLow
   List1.AddItem "TracksPerCylinder: " & dg.TracksPerCylinder
   List1.AddItem "SectorsPerTrack: " & dg.SectorsPerTrack
   List1.AddItem "BytesPerSector: " & dg.BytesPerSector
   Call CloseHandle(fhnd)

End Sub

