VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Drive Information"
   ClientHeight    =   3300
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   3930
   Height          =   3705
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   3300
   ScaleWidth      =   3930
   Top             =   1170
   Width           =   4050
   Begin VB.ListBox List2 
      Height          =   1200
      Left            =   240
      TabIndex        =   1
      Top             =   1860
      Width           =   3375
   End
   Begin VB.ListBox List1 
      Height          =   1200
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   3375
   End
   Begin VB.Label Label2 
      Caption         =   "Volume Information"
      Height          =   195
      Left            =   240
      TabIndex        =   3
      Top             =   1620
      Width           =   3375
   End
   Begin VB.Label Label1 
      Caption         =   "Logical Drives"
      Height          =   195
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   3015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Const FS_CASE_IS_PRESERVED = &H2
Private Const FS_CASE_SENSITIVE = &H1
Private Const FS_UNICODE_STORED_ON_DISK = &H4
Private Const FS_PERSISTENT_ACLS = &H8
Private Const FS_FILE_COMPRESSION = &H10
Private Const FS_VOL_IS_COMPRESSED = &H8000

Private Sub Form_Load()
    Dim s$
    Dim n&
    s$ = String$(2048, 0)
    Call GetLogicalDriveStrings(2047, s$)
    Do
        n = InStr(s$, Chr$(0))
        If n > 1 Then
            List1.AddItem Left$(s$, n - 1)
            s$ = Mid$(s$, n + 1)
        End If
    Loop Until n <= 1
    List1.ListIndex = 0
End Sub

Private Sub List1_Click()
    Dim volbuf$, sysname$
    Dim serialnum&, sysflags&, componentlength&
    Dim res&
    List2.Clear
    volbuf$ = String$(256, 0)
    sysname$ = String$(256, 0)
    res = GetVolumeInformation(List1.Text, volbuf$, 255, serialnum, _
            componentlength, sysflags, sysname$, 255)
    If res = 0 Then
        List2.AddItem "Unable to retrieve volume information"
    Else
        List2.AddItem "Volume: " & agGetStringFromLPSTR(volbuf$)
        List2.AddItem "Serial#: " & serialnum
        List2.AddItem "Component Length: " & componentlength
        List2.AddItem "File system: " & agGetStringFromLPSTR(sysname$)
        If sysflags And FS_CASE_IS_PRESERVED Then
            List2.AddItem "Case is preserved"
        End If
        If sysflags And FS_CASE_SENSITIVE Then
            List2.AddItem "File system is case sensitive"
        End If
        If sysflags And FS_UNICODE_STORED_ON_DISK Then
            List2.AddItem "Filenames are stored as Unicode"
        End If
        If sysflags And FS_PERSISTENT_ACLS Then
            List2.AddItem "Access control is supported."
        End If
        If sysflags And FS_FILE_COMPRESSION Then
            List2.AddItem "Individual files may be compressed"
        End If
        If sysflags And FS_VOL_IS_COMPRESSED Then
            List2.AddItem "Entire volume is compressed"
        End If
    End If
End Sub
